﻿using System;
using System.IO.MemoryMappedFiles;
using System.Text;

class Program
{
    // C# Memorymappedfile 재 업로드 드립니다.(실행순서 및 질문내용 정리)
    // http://www.sysnet.pe.kr/3/0/5232

    static void Main(string[] args)
    {
        MyFile mf = new MyFile();

        mf.WriteTextToMMF("test1.txt", Guid.NewGuid().ToString());
        mf.WriteTextToMMF("test2.txt", Guid.NewGuid().ToString());

        //GC.Collect();
        //GC.Collect();

        Console.WriteLine(mf.ReadContentFromMMF("test1.txt"));
    }
}

class MyFile
{
    MemoryMappedFile _mmf;

    public void WriteTextToMMF(string name, string contents)
    {
        byte[] buffer = Encoding.UTF8.GetBytes(contents);
        _mmf = MemoryMappedFile.CreateOrOpen(name, buffer.Length, MemoryMappedFileAccess.ReadWrite);

        using (MemoryMappedViewAccessor mmfWriter = _mmf.CreateViewAccessor())
        {
            mmfWriter.WriteArray<byte>(0, buffer, 0, buffer.Length);
        }
    }

    public string ReadContentFromMMF(string name)
    {
        using (MemoryMappedFile mmf2 = MemoryMappedFile.OpenExisting(name, MemoryMappedFileRights.Read))
        {
            using (MemoryMappedViewAccessor mmfReader = mmf2.CreateViewAccessor(0, 0, MemoryMappedFileAccess.Read))
            {
                byte[] buffer = new byte[36];
                mmfReader.ReadArray<byte>(0, buffer, 0, buffer.Length);

                return Encoding.UTF8.GetString(buffer);
            }
        }
    }
}

