﻿<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:msxsl="urn:schemas-microsoft-com:xslt" exclude-result-prefixes="msxsl"
    xmlns:xcgs="http://www.sysnet.pe.kr/CppProfilerCodeGenerator"
>
  <xsl:output method="xml" indent="yes"/>

  <xsl:template match="items">
namespace CodeGen
{
    <xsl:apply-templates></xsl:apply-templates>
}    
  </xsl:template>

  <xsl:template match="KeyName">
    public partial class <xsl:value-of select="@name"/>
    {
      <xsl:for-each select="prop">
        public const string <xsl:value-of select="@name"/> = "<xsl:if test="string(@value) = ''"><xsl:value-of select="@name"/></xsl:if><xsl:if test="string(@value) != ''"><xsl:value-of select="@value"/></xsl:if>";
      </xsl:for-each>

        public readonly string [] names = new string []
        {
            <xsl:for-each select="prop">
            "<xsl:value-of select="@name"/>",
            </xsl:for-each>
        };
        
        public bool HasName(string value)
        {
            switch (value)
            {
            <xsl:for-each select="prop">
                case "<xsl:value-of select="@name"/>":
                    return true;
            </xsl:for-each>
#if DEBUG
                default:
                    throw new System.ApplicationException("NOTFOUND: " + value);
#endif
            }

#if !DEBUG
            return false;
#endif            
        }
    }
  </xsl:template>
  
<msxsl:script language="JScript" implements-prefix="xcgs">
    <![CDATA[

  function ToLowerCase(variableName)
  {
    return variableName.toLowerCase();
  }  
  
]]>

</msxsl:script>

      
</xsl:stylesheet>
