﻿using IronPython.Hosting;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading;

namespace PythonHost
{
    // NuGet-PM> Install-Package IronPython
    //      IronPython.dll
    //      IronPython.Modules.dll
    //      IronPython.SQLite.dll
    //      IronPython.Wpf.dll

    // .NET 4.5/.NET Core 2.1 의존
    public class Program
    {
        public int Count;

        static void Main(string[] args)
        {
            Thread t = new Thread(threadFunc);
            t.IsBackground = true;
            t.Start();

            t.Join();
        }

        private static void threadFunc()
        {
            Program pg = new Program();
            var scriptEngine = Python.CreateEngine();

            while (true)
            {
                Thread.Sleep(2000);

                var scriptScope = scriptEngine.CreateScope();
                {
                    string txt = File.ReadAllText("myscript.py");
                    scriptEngine.Execute(txt, scriptScope);

                    dynamic mainFunc = scriptScope.GetVariable("main");
                    mainFunc(pg);
                }

                pg.Count++;
            }
        }
    }
}
